//---------------------------
//- GameMode VIP
//- By AGlass0fMilk
//- Version 1
//---------------------------

//Im going to go ahead and thank Space Guy for most of his code from TDM for these
//And for the support Gamemode System

registerGameMode("VIP","VIP",1,1,1);
setGameModeHelp("VIP","Add-ons/Gamemode_VIP/help_VIP.txt");
addGameModeRule("VIP","Time","int 0 30",0);
addGameModeRule("VIP","Points","int 0 10000",0);

function GameMode_VIP_onModeUpdateRule0(%mini,%rulevalue,%oldvalue,%modestart)
{
   if(%modestart)
      return;

   if(%rulevalue == %oldvalue)
      return 0;

   if(%rulevalue != %oldvalue)
   {
      return 1;
   }
}

function GameMode_VIP_onModeUpdateRule1(%mini,%rulevalue,%oldvalue,%modestart)
{
   if(%modestart)
      return;

   if(%rulevalue == %oldvalue)
      return 0;

   if(%rulevalue != %oldvalue)
   {
      return 1;
   }
}

function GameMode_VIP_OnMiniReset(%mini,%client)
{
   if(%mini.tdmModeRule[0] != 0)
      %mini.messageAll('',"\c5This round lasts \c3" @ %mini.tdmModeRule[0] @ "\c5 minute" @ (%mini.tdmModeRule[0] == 1 ? "" : "s") @ ".");
   
   if(%mini.tdmModeRule[1] != 0)
      %mini.messageAll('',"\c5The first team to reach \c3" @ %mini.tdmModeRule[1] @ "\c5 point" @ (%mini.tdmModeRule[1] == 1 ? "" : "s") @ " wins.");
   
   %mini.setTimeLimit(%mini.tdmModeRule[0]);
   %mini.setPointsLimit(%mini.tdmModeRule[1]);
   
   for(%i=0;%i<6;%i++)
   {
      if(%mini.teamExists[%i])
      {
         %mini.randomVIP(%i);
      }
   }
}

function GameMode_VIP_onTimeLimit(%mini)
{
   //Edited version of Minigame::roundEnd to find the highest scores and make those people win
   //Both teams and players in no team can win the round
   
   if(%mini.roundWon)
      return;
   
   %highestScore = %mini.member0.score;
   
   for(%i=0;%i<%mini.numMembers;%i++)
   {
      %cl = %mini.member[%i];      
      if(%cl.score $= "")
         %cl.score = 0;
      if(%mini.teamExists[%cl.tdmTeam] && %cl.tdmTeam != -1)
      {
         %score[%cl.tdmTeam] += %mini.member[%i].score;
      }
      else if(%cl.score > %highestScore)
      {
         %highestScore = %cl.score;
      }
   }
   
   for(%i=0;%i<6;%i++)
   {
      if(%score[%i] $= "")
         %score[%i] = 0;
      if(%mini.teamExists[%i] && %score[%i] > %highestScore)
      {
         %highestScore = %score[%i];
      }
   }
   
   %winCount = -1;
   
   for(%i=0;%i<6;%i++)
   {
      if(%mini.teamExists[%i])
      {
         if(%score[%i] == %highestScore)
         {
            %wins[%winCount++] = teamName(%mini,%i);
         }
      }
   }
   
   for(%i=0;%i<%mini.numMembers;%i++)
   {
      %cl = %mini.member[%i];
      if(%cl.tdmTeam == -1)
      {
         if(%cl.score == %highestScore)
         {
            %wins[%winCount++] = "\c3" @ %cl.getPlayerName();
            if(isObject(%cl.player) && %cl.player.getState() !$= "Dead")
               %cl.player.emote(winStarProjectile,1);
            %cl.tdmRoundsWon++;
            %cl.play2d(rewardSound);
         }
      }
      else if(%score[%cl.tdmTeam] == %highestScore)
      {
         if(isObject(%cl.player) && %cl.player.getState() !$= "Dead")
            %cl.player.emote(winStarProjectile,1);
         %cl.tdmRoundsWon++;
         %cl.play2d(rewardSound);
      }
   }
   
   //%winCount cannot be zero as long as there is a player in the minigame
   //which there should be unless you're hacking it to bits for a dedicated
   //even so, the message won't actually be displayed to anyone if that's the case so it should be okay
   %msg = %wins[0];
   if(%winCount > 0)
   {
      for(%i=1;%i<%winCount;%i++)
         %msg = %msg @ "\c5, " @ %wins[%i];
      %msg = %msg @ "\c5 and " @ %wins[%winCount];
   }
   %msg = %msg @ "\c5 won this round with \c3" @ %highestScore @ "\c5 point" @ (%highestScore == 1 ? "" : "s") @ ". Resetting in five seconds...";
   %mini.messageAll('',%msg);
   
   %mini.roundWon = 1;
   %mini.roundSwapTeams = 0;
   %mini.schedule(5000,reset,%mini.owner);
}

//This is to make special teams, it's a pain to do all these colors and uniforms and whatnot, In my opinion...
function GameMode_VIP_GetSpecialTeams(%client)
{
  //BodyGuards wear Black apparel, and they have sunglasses on if you have that face pack.
  //They look like the secret service
  commandToClient(%client,'tdmSpecialClearTeams');
  commandToClient(%client,'tdmSpecialSendTeam',0,"Body Guards" TAB
						       getClosestPaintColor("0.7 0.7 0.7 1") TAB
						       1 TAB
						       PlayerStandardArmor.getID() TAB
						       gunItem.getID() TAB
						       "NONE" TAB
						       "NONE" TAB
						       "NONE" TAB
						       "NONE" TAB
						       PlayerStandardArmor.getID() TAB
						       gunItem.getID() TAB
   							"NONE" TAB
   							"NONE" TAB
   							"NONE" TAB
   							"NONE");

  //chest		chestCol
  //rArm		rArmCol
  //lArm		lArmCol
  //rHand		rHandCol
  //lHand		lHandCol
  //---------------------------------
  //pants		pantsCol
  //rLeg		rLegCol
  //lLeg		lLegCol
  //hat			hatCol
  //accent		accentCol
  //---------------------------------
  //pack		packCol
  //secondPack		secondPackCol
  //headCol
  //decalName		faceName

   commandToClient(%client,'tdmSpecialStoreUniform',0,0,"0" TAB "0 0 0 1" TAB
							"0" TAB "0 0 0 1" TAB
							"0" TAB "0 0 0 1" TAB
							"0" TAB "1 0.878431 0.611765 1" TAB
							"0" TAB "1 0.878431 0.611765 1");

   commandtoclient(%client,'tdmSpecialStoreUniform',0,1,"0" TAB "0 0 0 1" TAB
							"0" TAB "0.0784314 0.0784314 0.0784314 1" TAB
							"0" TAB "0.0784314 0.0784314 0.0784314 1" TAB
							"6" TAB "0.0784314 0.0784314 0.0784314 1" TAB
							"0" TAB "0 0 0 1");

//I like the Sunglasses face from Demians Face Pack, it fits the style of this team, so if they have it, use it!
if(isFile("Add-Ons/Face_DemiansFacePack/SunGlassGuy.png"))
{
   commandtoclient(%client,'tdmSpecialStoreUniform',0,2,"0" TAB "0 0 0 1" TAB
							"0" TAB "0 0 0 1" TAB
							"1 0.88 0.61 1" TAB
							"Mod-Suit" TAB "SunGlassGuy");
}
else
{
   commandtoclient(%client,'tdmSpecialStoreUniform',0,2,"0" TAB "0 0 0 1" TAB
							"0" TAB "0 0 0 1" TAB
							"1 0.88 0.61 1" TAB
							"Mod-Suit" TAB "smiley");
}

//Now for the leader's uniform, he wears basically the same stuff
   commandToClient(%client,'tdmSpecialStoreLUniform',0,0,"0" TAB "0 0 0 1" TAB
							 "0" TAB "0 0 0 1" TAB
							 "0" TAB "0 0 0 1" TAB
							 "0" TAB "1 0.878431 0.611765 1" TAB
							 "0" TAB "1 0.878431 0.611765 1");

   commandToClient(%client,'tdmSpecialStoreLUniform',0,1,"0" TAB "0 0 0 1" TAB
							 "0" TAB "0.0784314 0.0784314 0.0784314 1" TAB
							 "0" TAB "0.0784314 0.0784314 0.0784314 1" TAB
							 "6" TAB "0.0784314 0.0784314 0.0784314 1" TAB
							 "0" TAB "0 0 0 1");

//And for the leader, I like Jirues Suit, so if they have it, use it!
if(isFile("Add-Ons/Decal_Jirue/DrKleiner.png"))
{
   commandToClient(%client,'tdmSpecialStoreLUniform',0,1,"0" TAB "0 0 0 1" TAB
							 "0" TAB "0 0 0 1" TAB
							 "1 0.878431 0.611765 1" TAB
							 "DrKleiner" TAB "memeHappy");
}
else
{
   commandToClient(%client,'tdmSpecialStoreLUniform',0,1,"0" TAB "0 0 0 1" TAB
							 "0" TAB "0 0 0 1" TAB
							 "1 0.878431 0.611765 1" TAB
							 "Mod-Suit" TAB "memeHappy");
}

//Then the Assassins team is next
//'Black' team, standard player, given a Gun. This is supposed to work with the basics of Blockland...
commandToClient(%client,'tdmSpecialSendTeam',1,"Assassins" TAB
							 getClosestPaintColor("0 0 0 1") TAB
							 1 TAB
							 PlayerStandardArmor.getID() TAB
							 gunItem.getID() TAB
							 "NONE" TAB
							 "NONE" TAB
							 "NONE" TAB
							 swordItem.getID() TAB
							 PlayerStandardArmor.getID() TAB
							 gunItem.getID() TAB
							 "NONE" TAB
							 "NONE" TAB
							 "NONE" TAB
							 swordItem.getID());
//The assassins wear an all black uniform basically
commandToClient(%client,'tdmSpecialStoreUniform',1,0,"0" TAB "0 0 0 1" TAB
						     "0" TAB "0 0 0 1" TAB
						     "0" TAB "0 0 0 1" TAB
						     "0" TAB "0 0 0 1" TAB
						     "0" TAB "0 0 0 1");

commandToClient(%client,'tdmSpecialStoreUniform',1,1,"0" TAB "0 0 0 1" TAB
						     "0" TAB "0.0784314 0.0784314 0.0784314 1" TAB
						     "0" TAB "0.0784314 0.0784314 0.0784314 1" TAB
						     "7" TAB "0.0784314 0.0784314 0.0784314 1" TAB
						     "0" TAB "0 0 0 1");

//Now I like the skimask for assassins, but it isn't default, so if they have it, use it!
if(isFile("Add-ons/Face_SkiMask/Skimask11.png"))
{
   commandToClient(%client,'tdmSpecialStoreUniform',1,2,"0" TAB "0 0 0 1" TAB
							"0" TAB "0 0 0 1" TAB
							"0.0784314 0.0784314 0.0784314 1" TAB
							"AAA-None" TAB "Skimask11");
}
else
{
   commandToClient(%client,'tdmSpecialStoreUniform',1,2,"0" TAB "0 0 0 1" TAB
							"0" TAB "0 0 0 1" TAB
							"0.0784314 0.0784314 0.0784314 1" TAB
							"AAA-None" TAB "smileyEvil1");
}}

//Since this gamemode will only allow points to people who kill VIP's, I have to do this
//Yeah I know, this is full of If's and it's sloppy, get over it...
function GameMode_VIP_onClientDeath(%mini,%client,%sourceObject,%sourceClient,%damageType,%damageArea)
{
   %team = %client.tdmTeam;
   if(%team == %sourceClient.tdmTeam && %team != -1)
   {
      %teamkill = 1;
   }
   if(%mini.teamLeader[%team] != %client && %teamkill != 1)
   {
      %sourceClient.incScore(-%client.minigame.points_KillPlayer);
   }
   if(%mini.teamLeader[%team] == %client && !isObject(%sourceClient.player))
   {
      %name = %mini.teamName[%team];
      %s = (getSubStr(%name,strLen(%name)-1,1) $= "s");
      %str = teamName(%mini,%team) @ "'" @ (%s ? "" : "s");
      %mini.messageAll('',"\c5The\c3 "@ %str @"\c5 VIP has been killed");
      %mini.schedule(500,"randomVIP",%team);
   }
   if(%mini.teamLeader[%team] == %client && %damageType == 2)
   {
      %name = %mini.teamName[%team];
      %s = (getSubStr(%name,strLen(%name)-1,1) $= "s");
      %str = teamName(%mini,%team) @ "'" @ (%s ? "" : "s");
      %mini.messageAll('',"\c5The \c3"@ %str @"\c5 VIP killed themselves");
      %mini.schedule(500,"randomVIP",%team);
   }
   if(%mini.teamLeader[%team] == %client && isObject(%sourceClient.player) && %damageType != 2)
   {
      %name = %mini.teamName[%team];
      %s = (getSubStr(%name,strLen(%name)-1,1) $= "s");
      %str = teamName(%mini,%team) @ "'" @ (%s ? "" : "s");
      %mini.messageAll('',"\c3"@ %sourceClient.getPlayerName() @"\c5 has killed the \c3"@ %str @"\c5 VIP,\c3 "@ %client.getPlayerName() @"\c5!");
      %mini.schedule(500,"randomVIP",%team);
   }
}

//This gets a random player on a team, and makes them the leader.
function MinigameSO::randomVIP(%mini,%team)//Thanks to Space Guy for a lot of this part
{
   if(!%mini.teamExists[%team])
      return;
   
   %num = -1;
   for(%i=0;%i<%mini.numMembers;%i++)
   {
      %cl = %mini.member[%i];
      if(%cl.tdmTeam == %team)
         %c[%num++] = %cl;
   }
   
   if(%num == -1)
   {
      //Nobody is in the team. Pick a random person.
      %num = 0;
      %cl = %mini.member[getRandom(0,%mini.numMembers-1)];
      %cl.setTeam(%team);
      %c[%num] = %cl;
   }
   
   //Turn ' Red ' into ' Red's ', ' Attackers ' into ' Attackers' '.
   %name = %mini.teamName[%team];
   %s = (getSubStr(%name,strLen(%name)-1,1) $= "s");
   %str = teamName(%mini,%team) @ "'" @ (%s ? "" : "s");
   
   //Pick a random leader, or the same if nobody else is in the team
   %v = %c[getRandom(0,%num)];
   while(%v == %mini.teamLeader[%team] && %num > 0)
      %v = %c[getRandom(0,%num)];
   
   if(%v == %mini.teamLeader[%team])
   {
      %mini.messageAll('',"\c3" @ %v.getPlayerName() @ "\c5 is still the " @ %str @ " \c3VIP\c5.");
      %v.centerPrint("<color:00CC00>You are the VIP!",3);
      %v.instantRespawn();
   }
   else
   {
      %l = %mini.teamLeader[%team];
      %mini.teamLeader[%team] = %v;
      %mini.messageAll('',"\c3" @ %v.getPlayerName() @ "\c5 is now the " @ %str @ " \c3VIP\c5.");
      %v.instantRespawn();
      %v.centerPrint("<color:00CC00>You are the VIP!",3);
      if(isObject(%l))
         %l.instantRespawn();
   }
}